from typing import Iterator

from biobit.core.loc import Interval, IntoInterval


class Elements[T]:
    def __init__(self) -> None: ...

    @staticmethod
    def from_existent(segments: list[list[IntoInterval]], elements: list[list[T]]) -> 'Elements[T]': ...

    @property
    def intervals(self) -> list[list[Interval]]: ...

    @property
    def elements(self) -> list[list[T]]: ...

    def clear(self) -> None: ...

    def __iter__(self) -> Iterator[tuple[list[Interval], list[T]]]: ...

    def __len__(self) -> int: ...


class Steps[T]:
    def __init__(self) -> None: ...

    def build(self, elements: Elements[T], query: list[IntoInterval]) -> None: ...

    def clear(self) -> None: ...

    def __iter__(self) -> Iterator[tuple[IntoInterval, set[T]]]: ...

    def __len__(self) -> int: ...
